﻿// MassSprite - part of SpringSim collection - Actionscript 3 - Jim Bumgardner 2008
//

package {
	import flash.events.Event;
	import flash.display.Sprite;
	import flash.utils.getTimer;
	
	public class MassSprite extends Sprite
	{
		public var hilite:Boolean = false;
		public var isAnchor:Boolean = false;
		public var isDragging:Boolean = false;
		public var renderDot:Boolean = false;
		public var isSelected:Boolean = false;
		var fx,fy,vx,vy,ox,oy,lastSelect;
		var creationTime;
		var ss;
		public var idx;
		public var subMC;
		public var showDot = drawDot;
		
		public function MassSprite(ss, subMC=null)
		{
			this.ss = ss;
			this.buttonMode = true;
			vx = vy = fx = fy = 0;
			ox = oy = 0;
			if (subMC) {
				this.subMC = subMC;
				addChild(subMC);
			}
		}

		function overDot(evt)
		{
			trace("over " + this); 
			ss.isOverDot = true;  
			hilite = true; 
			drawDot();
		}
		
		function outofDot(evt)
		{
			ss.isOverDot = false;  
			hilite = false; 
			drawDot();
		}
		
		// drawDot...
		// setDotProps
		
		// This is what happens when we start dragging an anchor point
		//
		function pressDot(evt)
		{
			if (ss.editMode == 0) {	// normal simulation
				isDragging = true;
				ss.dragDot = this;
				ss.isOverDot = true;
				startDrag(false);
			}
			else {							// edit mode / delete mode
				ox = this.x;
				oy = this.y;
				lastSelect = ss.selectedDot;
				ss.doSelectDot(undefined);
				isDragging = true;
				ss.dragDot = this;
				ss.isOverDot = true;
				startDrag(false);
				this.addEventListener(Event.ENTER_FRAME, ss.drawSprings);
				// _root.onEnterFrame = function() { this.ss.drawSprings(); }
			}
		}
		
		// This is what happens when we start release an anchor point
		//
		function releaseDot(evt)
		{
			switch (ss.editMode) {
			case 0:						// normal simulation
				stopDrag();
				isDragging = false;
				ss.dragDot = undefined;
				break;
			case 1:						// edit mode
				this.removeEventListener(Event.ENTER_FRAME, ss.drawSprings);
				stopDrag();
				var wasDragging = isDragging;
				isDragging = false;
				ss.dragDot = undefined;
				var wasDragged = Math.abs(this.ox - this.x) >= 3 || Math.abs(this.oy - this.y) >= 3;
				var newlyCreated = getTimer() - this.creationTime < 1000;
				if (!wasDragged && lastSelect != undefined && lastSelect != this && !hasSpringTo(lastSelect))
					ss.addSpring(lastSelect, this);
					
				if (lastSelect != this || wasDragged || newlyCreated) {
					ss.doSelectDot(this);
				}
				break;
			case 2:						// delete mode
				ss.deleteDot(this);
				break;
			}
		}

		function setDotProps(isAnchor,renderDot)
		{
			this.isAnchor = isAnchor;
			this.renderDot = renderDot;
			this.vx = this.vy = 0;
			drawDot();
			ss.drawSprings();
		}
		
		function drawDot()
		{
			graphics.clear();
			graphics.beginFill((isAnchor? 0x770000 : 0x000077), renderDot? 100 : 0);
			graphics.drawCircle(0,0, hilite? SpringSim.dotRad*1.5 : SpringSim.dotRad);
			graphics.endFill();
			if (isSelected) 
			{
				graphics.lineStyle(1, 0xFF7700,100);
				graphics.drawCircle(0,0, SpringSim.dotRad*2);
			}
		}
		
		function hasSpringTo(mc):Boolean
		{
			for (var i = ss.springs.length-1; i >= 0; --i)
			{
				var spr = ss.springs[i];
				if ((spr.dot1 == mc && spr.dot2 == this) ||
					(spr.dot1 == this && spr.dot2 == mc)) 
				{
					// trace("spring already exists");
					return true;
				}
			}
			return false;
		}
		
	} //end class
	
} // end package